from stdlib.string cimport Str
from stdlib.socket cimport getaddrinfo, socket, AF_UNSPEC, SOCK_STREAM, AI_PASSIVE, MSG_WAITALL, SHUT_WR, SHUT_RD

from libc.stdio cimport puts, printf

def main():
    cdef const char * arg
    while True:
        b = input("Message to send:\n").encode()
        arg = b
        with nogil:
            a = getaddrinfo(NULL, Str("3490"), AF_UNSPEC, SOCK_STREAM, 0, AI_PASSIVE)[0]

            s = socket(a.family, a.socktype, a.protocol)
            puts('open: ok')

            s.connect(a.sockaddr)
            puts('connect: ok')

            msg = Str(arg)
            s.sendall(msg)
            puts('send: ok')

            s.shutdown(SHUT_WR)

            r = Str('')
            while True:
                rcv = s.recv(100)
                if rcv.__len__() > 0:
                    printf('recv: %s\n', Str.to_c_str(rcv))
                    r = r + rcv
                else:
                    puts('connection closed by server')
                    break

            printf('got: %s\n', Str.to_c_str(r))

            s.close()
            puts('close: ok')

main()
